rebase: fix run_specific_rebase's use of "return" on FreeBSD
[alt-git.git] / git-rebase.sh
blob7ab6434a4ff9e95d639bdf7914e50fb327abe8af
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano.
6 SUBDIRECTORY_OK=Yes
7 OPTIONS_KEEPDASHDASH=
8 OPTIONS_SPEC="\
9 git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] [<upstream>] [<branch>]
10 git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] --root [<branch>]
11 git-rebase --continue | --abort | --skip | --edit-todo
13 Available options are
14 v,verbose! display a diffstat of what changed upstream
15 q,quiet! be quiet. implies --no-stat
16 onto=! rebase onto given branch instead of upstream
17 p,preserve-merges! try to recreate merges instead of ignoring them
18 s,strategy=! use the given merge strategy
19 no-ff! cherry-pick all commits, even if unchanged
20 m,merge! use merging strategies to rebase
21 i,interactive! let the user edit the list of commits to rebase
22 x,exec=! add exec lines after each commit of the editable list
23 k,keep-empty preserve empty commits during rebase
24 f,force-rebase! force rebase even if branch is up to date
25 X,strategy-option=! pass the argument through to the merge strategy
26 stat! display a diffstat of what changed upstream
27 n,no-stat! do not show diffstat of what changed upstream
28 verify allow pre-rebase hook to run
29 rerere-autoupdate allow rerere to update index with resolved conflicts
30 root! rebase all reachable commits up to the root(s)
31 autosquash move commits that begin with squash!/fixup! under -i
32 committer-date-is-author-date! passed to 'git am'
33 ignore-date! passed to 'git am'
34 whitespace=! passed to 'git apply'
35 ignore-whitespace! passed to 'git apply'
36 C=! passed to 'git apply'
37 Actions:
38 continue! continue
39 abort! abort and check out the original branch
40 skip! skip current patch and continue
41 edit-todo! edit the todo list during an interactive rebase
43 . git-sh-setup
44 . git-sh-i18n
45 set_reflog_action rebase
46 require_work_tree_exists
47 cd_to_toplevel
49 LF='
51 ok_to_skip_pre_rebase=
52 resolvemsg="
53 $(gettext 'When you have resolved this problem, run "git rebase --continue".
54 If you prefer to skip this patch, run "git rebase --skip" instead.
55 To check out the original branch and stop rebasing, run "git rebase --abort".')
57 unset onto
58 cmd=
59 strategy=
60 strategy_opts=
61 do_merge=
62 merge_dir="$GIT_DIR"/rebase-merge
63 apply_dir="$GIT_DIR"/rebase-apply
64 verbose=
65 diffstat=
66 test "$(git config --bool rebase.stat)" = true && diffstat=t
67 git_am_opt=
68 rebase_root=
69 force_rebase=
70 allow_rerere_autoupdate=
71 # Non-empty if a rebase was in progress when 'git rebase' was invoked
72 in_progress=
73 # One of {am, merge, interactive}
74 type=
75 # One of {"$GIT_DIR"/rebase-apply, "$GIT_DIR"/rebase-merge}
76 state_dir=
77 # One of {'', continue, skip, abort}, as parsed from command line
78 action=
79 preserve_merges=
80 autosquash=
81 keep_empty=
82 test "$(git config --bool rebase.autosquash)" = "true" && autosquash=t
84 read_basic_state () {
85 head_name=$(cat "$state_dir"/head-name) &&
86 onto=$(cat "$state_dir"/onto) &&
87 # We always write to orig-head, but interactive rebase used to write to
88 # head. Fall back to reading from head to cover for the case that the
89 # user upgraded git with an ongoing interactive rebase.
90 if test -f "$state_dir"/orig-head
91 then
92 orig_head=$(cat "$state_dir"/orig-head)
93 else
94 orig_head=$(cat "$state_dir"/head)
95 fi &&
96 GIT_QUIET=$(cat "$state_dir"/quiet) &&
97 test -f "$state_dir"/verbose && verbose=t
98 test -f "$state_dir"/strategy && strategy="$(cat "$state_dir"/strategy)"
99 test -f "$state_dir"/strategy_opts &&
100 strategy_opts="$(cat "$state_dir"/strategy_opts)"
101 test -f "$state_dir"/allow_rerere_autoupdate &&
102 allow_rerere_autoupdate="$(cat "$state_dir"/allow_rerere_autoupdate)"
105 write_basic_state () {
106 echo "$head_name" > "$state_dir"/head-name &&
107 echo "$onto" > "$state_dir"/onto &&
108 echo "$orig_head" > "$state_dir"/orig-head &&
109 echo "$GIT_QUIET" > "$state_dir"/quiet &&
110 test t = "$verbose" && : > "$state_dir"/verbose
111 test -n "$strategy" && echo "$strategy" > "$state_dir"/strategy
112 test -n "$strategy_opts" && echo "$strategy_opts" > \
113 "$state_dir"/strategy_opts
114 test -n "$allow_rerere_autoupdate" && echo "$allow_rerere_autoupdate" > \
115 "$state_dir"/allow_rerere_autoupdate
118 output () {
119 case "$verbose" in
121 output=$("$@" 2>&1 )
122 status=$?
123 test $status != 0 && printf "%s\n" "$output"
124 return $status
127 "$@"
129 esac
132 move_to_original_branch () {
133 case "$head_name" in
134 refs/*)
135 message="rebase finished: $head_name onto $onto"
136 git update-ref -m "$message" \
137 $head_name $(git rev-parse HEAD) $orig_head &&
138 git symbolic-ref \
139 -m "rebase finished: returning to $head_name" \
140 HEAD $head_name ||
141 die "$(gettext "Could not move back to $head_name")"
143 esac
146 run_specific_rebase_internal () {
147 if [ "$interactive_rebase" = implied ]; then
148 GIT_EDITOR=:
149 export GIT_EDITOR
150 autosquash=
152 # On FreeBSD, the shell's "return" returns from the current
153 # function, not from the current file inclusion.
154 # run_specific_rebase_internal has the file inclusion as a
155 # last statement, so POSIX and FreeBSD's return will do the
156 # same thing.
157 . git-rebase--$type
160 run_specific_rebase () {
161 run_specific_rebase_internal
162 ret=$?
163 if test $ret -eq 0
164 then
165 git gc --auto &&
166 rm -rf "$state_dir"
168 exit $ret
171 run_pre_rebase_hook () {
172 if test -z "$ok_to_skip_pre_rebase" &&
173 test -x "$GIT_DIR/hooks/pre-rebase"
174 then
175 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
176 die "$(gettext "The pre-rebase hook refused to rebase.")"
180 test -f "$apply_dir"/applying &&
181 die "$(gettext "It looks like git-am is in progress. Cannot rebase.")"
183 if test -d "$apply_dir"
184 then
185 type=am
186 state_dir="$apply_dir"
187 elif test -d "$merge_dir"
188 then
189 if test -f "$merge_dir"/interactive
190 then
191 type=interactive
192 interactive_rebase=explicit
193 else
194 type=merge
196 state_dir="$merge_dir"
198 test -n "$type" && in_progress=t
200 total_argc=$#
201 while test $# != 0
203 case "$1" in
204 --no-verify)
205 ok_to_skip_pre_rebase=yes
207 --verify)
208 ok_to_skip_pre_rebase=
210 --continue|--skip|--abort|--edit-todo)
211 test $total_argc -eq 2 || usage
212 action=${1##--}
214 --onto)
215 test 2 -le "$#" || usage
216 onto="$2"
217 shift
220 test 2 -le "$#" || usage
221 cmd="${cmd}exec $2${LF}"
222 shift
225 interactive_rebase=explicit
228 keep_empty=yes
231 preserve_merges=t
232 test -z "$interactive_rebase" && interactive_rebase=implied
234 --autosquash)
235 autosquash=t
237 --no-autosquash)
238 autosquash=
240 -M|-m)
241 do_merge=t
244 shift
245 strategy_opts="$strategy_opts $(git rev-parse --sq-quote "--$1")"
246 do_merge=t
247 test -z "$strategy" && strategy=recursive
250 shift
251 strategy="$1"
252 do_merge=t
255 diffstat=
257 --stat)
258 diffstat=t
261 verbose=t
262 diffstat=t
263 GIT_QUIET=
266 GIT_QUIET=t
267 git_am_opt="$git_am_opt -q"
268 verbose=
269 diffstat=
271 --whitespace)
272 shift
273 git_am_opt="$git_am_opt --whitespace=$1"
274 case "$1" in
275 fix|strip)
276 force_rebase=t
278 esac
280 --ignore-whitespace)
281 git_am_opt="$git_am_opt $1"
283 --committer-date-is-author-date|--ignore-date)
284 git_am_opt="$git_am_opt $1"
285 force_rebase=t
288 shift
289 git_am_opt="$git_am_opt -C$1"
291 --root)
292 rebase_root=t
294 -f|--no-ff)
295 force_rebase=t
297 --rerere-autoupdate|--no-rerere-autoupdate)
298 allow_rerere_autoupdate="$1"
301 shift
302 break
304 esac
305 shift
306 done
307 test $# -gt 2 && usage
309 if test -n "$cmd" &&
310 test "$interactive_rebase" != explicit
311 then
312 die "$(gettext "The --exec option must be used with the --interactive option")"
315 if test -n "$action"
316 then
317 test -z "$in_progress" && die "$(gettext "No rebase in progress?")"
318 # Only interactive rebase uses detailed reflog messages
319 if test "$type" = interactive && test "$GIT_REFLOG_ACTION" = rebase
320 then
321 GIT_REFLOG_ACTION="rebase -i ($action)"
322 export GIT_REFLOG_ACTION
326 if test "$action" = "edit-todo" && test "$type" != "interactive"
327 then
328 die "$(gettext "The --edit-todo action can only be used during interactive rebase.")"
331 case "$action" in
332 continue)
333 # Sanity check
334 git rev-parse --verify HEAD >/dev/null ||
335 die "$(gettext "Cannot read HEAD")"
336 git update-index --ignore-submodules --refresh &&
337 git diff-files --quiet --ignore-submodules || {
338 echo "$(gettext "You must edit all merge conflicts and then
339 mark them as resolved using git add")"
340 exit 1
342 read_basic_state
343 run_specific_rebase
345 skip)
346 output git reset --hard HEAD || exit $?
347 read_basic_state
348 run_specific_rebase
350 abort)
351 git rerere clear
352 read_basic_state
353 case "$head_name" in
354 refs/*)
355 git symbolic-ref -m "rebase: aborting" HEAD $head_name ||
356 die "$(eval_gettext "Could not move back to \$head_name")"
358 esac
359 output git reset --hard $orig_head
360 rm -r "$state_dir"
361 exit
363 edit-todo)
364 run_specific_rebase
366 esac
368 # Make sure no rebase is in progress
369 if test -n "$in_progress"
370 then
371 state_dir_base=${state_dir##*/}
372 cmd_live_rebase="git rebase (--continue | --abort | --skip)"
373 cmd_clear_stale_rebase="rm -fr \"$state_dir\""
374 die "
375 $(eval_gettext 'It seems that there is already a $state_dir_base directory, and
376 I wonder if you are in the middle of another rebase. If that is the
377 case, please try
378 $cmd_live_rebase
379 If that is not the case, please
380 $cmd_clear_stale_rebase
381 and run me again. I am stopping in case you still have something
382 valuable there.')"
385 if test -n "$rebase_root" && test -z "$onto"
386 then
387 test -z "$interactive_rebase" && interactive_rebase=implied
390 if test -n "$interactive_rebase"
391 then
392 type=interactive
393 state_dir="$merge_dir"
394 elif test -n "$do_merge"
395 then
396 type=merge
397 state_dir="$merge_dir"
398 else
399 type=am
400 state_dir="$apply_dir"
403 if test -z "$rebase_root"
404 then
405 case "$#" in
407 if ! upstream_name=$(git rev-parse --symbolic-full-name \
408 --verify -q @{upstream} 2>/dev/null)
409 then
410 . git-parse-remote
411 error_on_missing_default_upstream "rebase" "rebase" \
412 "against" "git rebase <branch>"
415 *) upstream_name="$1"
416 shift
418 esac
419 upstream=`git rev-parse --verify "${upstream_name}^0"` ||
420 die "$(eval_gettext "invalid upstream \$upstream_name")"
421 upstream_arg="$upstream_name"
422 else
423 if test -z "$onto"
424 then
425 empty_tree=`git hash-object -t tree /dev/null`
426 onto=`git commit-tree $empty_tree </dev/null`
427 squash_onto="$onto"
429 unset upstream_name
430 unset upstream
431 test $# -gt 1 && usage
432 upstream_arg=--root
435 # Make sure the branch to rebase onto is valid.
436 onto_name=${onto-"$upstream_name"}
437 case "$onto_name" in
438 *...*)
439 if left=${onto_name%...*} right=${onto_name#*...} &&
440 onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
441 then
442 case "$onto" in
443 ?*"$LF"?*)
444 die "$(eval_gettext "\$onto_name: there are more than one merge bases")"
447 die "$(eval_gettext "\$onto_name: there is no merge base")"
449 esac
450 else
451 die "$(eval_gettext "\$onto_name: there is no merge base")"
455 onto=$(git rev-parse --verify "${onto_name}^0") ||
456 die "$(eval_gettext "Does not point to a valid commit: \$onto_name")"
458 esac
460 # If the branch to rebase is given, that is the branch we will rebase
461 # $branch_name -- branch being rebased, or HEAD (already detached)
462 # $orig_head -- commit object name of tip of the branch before rebasing
463 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
464 switch_to=
465 case "$#" in
467 # Is it "rebase other $branchname" or "rebase other $commit"?
468 branch_name="$1"
469 switch_to="$1"
471 if git show-ref --verify --quiet -- "refs/heads/$1" &&
472 orig_head=$(git rev-parse -q --verify "refs/heads/$1")
473 then
474 head_name="refs/heads/$1"
475 elif orig_head=$(git rev-parse -q --verify "$1")
476 then
477 head_name="detached HEAD"
478 else
479 die "$(eval_gettext "fatal: no such branch: \$branch_name")"
483 # Do not need to switch branches, we are already on it.
484 if branch_name=`git symbolic-ref -q HEAD`
485 then
486 head_name=$branch_name
487 branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
488 else
489 head_name="detached HEAD"
490 branch_name=HEAD ;# detached
492 orig_head=$(git rev-parse --verify HEAD) || exit
495 die "BUG: unexpected number of arguments left to parse"
497 esac
499 require_clean_work_tree "rebase" "$(gettext "Please commit or stash them.")"
501 # Now we are rebasing commits $upstream..$orig_head (or with --root,
502 # everything leading up to $orig_head) on top of $onto
504 # Check if we are already based on $onto with linear history,
505 # but this should be done only when upstream and onto are the same
506 # and if this is not an interactive rebase.
507 mb=$(git merge-base "$onto" "$orig_head")
508 if test "$type" != interactive && test "$upstream" = "$onto" &&
509 test "$mb" = "$onto" &&
510 # linear history?
511 ! (git rev-list --parents "$onto".."$orig_head" | sane_grep " .* ") > /dev/null
512 then
513 if test -z "$force_rebase"
514 then
515 # Lazily switch to the target branch if needed...
516 test -z "$switch_to" || git checkout "$switch_to" --
517 say "$(eval_gettext "Current branch \$branch_name is up to date.")"
518 exit 0
519 else
520 say "$(eval_gettext "Current branch \$branch_name is up to date, rebase forced.")"
524 # If a hook exists, give it a chance to interrupt
525 run_pre_rebase_hook "$upstream_arg" "$@"
527 if test -n "$diffstat"
528 then
529 if test -n "$verbose"
530 then
531 echo "$(eval_gettext "Changes from \$mb to \$onto:")"
533 # We want color (if set), but no pager
534 GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
537 test "$type" = interactive && run_specific_rebase
539 # Detach HEAD and reset the tree
540 say "$(gettext "First, rewinding head to replay your work on top of it...")"
541 git checkout -q "$onto^0" || die "could not detach HEAD"
542 git update-ref ORIG_HEAD $orig_head
544 # If the $onto is a proper descendant of the tip of the branch, then
545 # we just fast-forwarded.
546 if test "$mb" = "$orig_head"
547 then
548 say "$(eval_gettext "Fast-forwarded \$branch_name to \$onto_name.")"
549 move_to_original_branch
550 exit 0
553 if test -n "$rebase_root"
554 then
555 revisions="$onto..$orig_head"
556 else
557 revisions="$upstream..$orig_head"
560 run_specific_rebase